<template>
  <div>
    <h2 id="page-heading" data-cy="DispositivoHeading">
      <span v-text="$t('gatewayApp.manillaDispositivo.home.title')" id="dispositivo-heading">Dispositivos</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaDispositivo.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'DispositivoCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-dispositivo"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaDispositivo.home.createLabel')"> Create a new Dispositivo </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && dispositivos && dispositivos.length === 0">
      <span v-text="$t('gatewayApp.manillaDispositivo.home.notFound')">No dispositivos found</span>
    </div>
    <div class="table-responsive" v-if="dispositivos && dispositivos.length > 0">
      <table class="table table-striped" aria-describedby="dispositivos">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('dispositivo')">
              <span v-text="$t('gatewayApp.manillaDispositivo.dispositivo')">Dispositivo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'dispositivo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('mac')">
              <span v-text="$t('gatewayApp.manillaDispositivo.mac')">Mac</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'mac'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('conectado')">
              <span v-text="$t('gatewayApp.manillaDispositivo.conectado')">Conectado</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'conectado'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.manillaDispositivo.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="dispositivo in dispositivos" :key="dispositivo.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'DispositivoView', params: { dispositivoId: dispositivo.id } }">{{ dispositivo.id }}</router-link>
            </td>
            <td>{{ dispositivo.dispositivo }}</td>
            <td>{{ dispositivo.mac }}</td>
            <td>{{ dispositivo.conectado }}</td>
            <td>
              {{ dispositivo.user ? dispositivo.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'DispositivoView', params: { dispositivoId: dispositivo.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'DispositivoEdit', params: { dispositivoId: dispositivo.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(dispositivo)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.manillaDispositivo.delete.question"
          data-cy="dispositivoDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-dispositivo-heading" v-text="$t('gatewayApp.manillaDispositivo.delete.question', { id: removeId })">
          Are you sure you want to delete this Dispositivo?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-dispositivo"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeDispositivo()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./dispositivo.component.ts"></script>
